<!doctype html>
<html lang="en">
 <head>
  <meta charset="UTF-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <meta name="generator" content="Asciidoctor 2.0.23">
  <meta name="author" content="Copyright (c) 2010, 2024 Contributors to the Eclipse Foundation">
  <link rel="icon" type="image/png" href="../favicon.png">
  <title>Customizing output | Eclipse ESCET™ development documentation</title>
  <link rel="stylesheet" href="../assets/asciidoctor-escet-dev.css">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/4.7.0/css/font-awesome.min.css">
  <link rel="stylesheet" href="../assets/styles/asciidoctor-highlightjs-escet.min.css"><!--
  Copyright (c) 2010, 2024 Contributors to the Eclipse Foundation

  See the NOTICE file(s) distributed with this work for additional
  information regarding copyright ownership.

  This program and the accompanying materials are made available under the terms
  of the MIT License which is available at https://opensource.org/licenses/MIT

  SPDX-License-Identifier: MIT
-->
  <meta name="robots" content="noindex">
  <script type="text/javascript" src="../assets/asciidoctor-escet-dev.js"></script>
 </head>
 <body class="book toc2 toc-left" onload="onLoad()">
  <div id="header">
   <div id="toc" class="toc2">
    <p class="website-link">Part of: <a href="../..">Eclipse ESCET™ website</a></p>
    <div id="toctitle">
     Eclipse ESCET™ development documentation
    </div>
    <ul class="sectlevel1">
     <li class="toc-item">
      <div class="toc-item-marker"></div><a href="../index.html">Home</a></li>
     <li class="toc-item toc-item-parent">
      <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../index.html#eclipse-escet-development">Eclipse ESCET development</a>
      <ul class="sectlevel2">
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../development/dev-list.html">The Eclipse ESCET dev-list</a></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../development/development-process.html">Development process</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../development/development-process.html#issue-tracking">Issue tracking</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../development/development-process.html#releases-and-milestones">Releases and milestones</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../development/development-process.html#working-on-issues">Working on issues</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../development/development-process.html#working-with-branches">Working with branches</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../development/development-process.html#commits">Commits</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../development/development-process.html#merge-requests">Merge requests</a></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../development/development-process.html#collaborating-with-contributors-on-a-merge-request">Collaborating with contributors on a merge request</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../development/development-process.html#simple-approach">Simple approach</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../development/development-process.html#advanced-approach">Advanced approach</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="../development/development-process.html#fork-collaboration-script-support">Fork collaboration script support</a></li>
          </ul></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../development/contributing.html">Contributing</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../development/contributing.html#how-to-contribute-to-eclipse-escet">How to contribute to Eclipse ESCET</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../development/contributing.html#keeping-in-sync-with-the-official-eclipse-escet-gitlab-repository">Keeping in sync with the official Eclipse ESCET GitLab repository</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../development/contributing.html#how-to-become-a-committer">How to become a committer</a></li>
        </ul></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../development/issue-tracking.html">Issue tracking</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../development/dev-env-setup.html">Development environment setup</a></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../development/git-repo.html">Git repositories</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../development/git-repo.html#repository-structure">Repository structure</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../development/git-repo.html#language-directories">Language directories</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../development/git-repo.html#middle-layer-common-functionality">Middle layer common functionality</a></li>
        </ul></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../development/coding-standards.html">Coding standards</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../development/building-and-testing.html">Building and testing</a></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../development/release-process.html">Release process</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../development/release-process.html#release-policy">Release policy</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../development/release-process.html#release-retention-policy">Release retention policy</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../development/release-process.html#planning-for-a-next-version">Planning for a next version</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../development/release-process.html#preparing-git-repository-for-a-next-version">Preparing Git repository for a next version</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../development/release-process.html#working-on-a-release">Working on a release</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../development/release-process.html#preparing-a-release">Preparing a release</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../development/release-process.html#preparing-a-progress-review">Preparing a progress review</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../development/release-process.html#performing-a-release">Performing a release</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../development/release-process.html#removing-archiving-old-releases">Removing/archiving old releases</a></li>
        </ul></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../development/third-party-tools.html">Third party tools</a></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../development/dependency-upgrades.html">Dependency upgrades</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../development/dependency-upgrades.html#eclipse-platform-ide-upgrades">Eclipse Platform/IDE upgrades</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../development/dependency-upgrades.html#tycho-upgrades">Tycho upgrades</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../development/dependency-upgrades.html#java-upgrades">Java upgrades</a></li>
        </ul></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../development/license-year-update.html">License year update</a></li>
      </ul></li>
     <li class="toc-item toc-item-parent">
      <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../app-framework/index.html">Application framework</a>
      <ul class="sectlevel2">
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../app-framework/introduction.html">Introduction</a></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../app-framework/standalone-vs-eclipse.html">Stand-alone execution versus Eclipse IDE</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/standalone-vs-eclipse.html#application-static-information">Application static information</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/standalone-vs-eclipse.html#application-options">Application options</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/standalone-vs-eclipse.html#stdin-stdout-and-stderr">Stdin, stdout, and stderr</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/standalone-vs-eclipse.html#graphical-user-interfaces-guis-and-swt">Graphical User Interfaces (GUIs) and SWT</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/standalone-vs-eclipse.html#application-termination">Application termination</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/standalone-vs-eclipse.html#sigint">SIGINT</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/standalone-vs-eclipse.html#exceptions">Exceptions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/standalone-vs-eclipse.html#system-properties">System properties</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/standalone-vs-eclipse.html#file-paths-and-current-working-directory">File paths and current working directory</a></li>
        </ul></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../app-framework/application-class.html">The Application class</a></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../app-framework/exception-framework.html">The exception framework</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/exception-framework.html#end-user-exceptions">End-user exceptions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/exception-framework.html#internal-exceptions">Internal exceptions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/exception-framework.html#chained-exceptions">Chained exceptions</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/exception-framework.html#development-mode">Development mode</a></li>
        </ul></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../app-framework/exit-codes.html">Exit codes</a></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../app-framework/io-framework.html">The I/O framework</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/io-framework.html#output-components">Output components</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/io-framework.html#output-provider">Output provider</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/io-framework.html#stdout-and-stderr">Stdout and stderr</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/io-framework.html#stdin">Stdin</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/io-framework.html#buffering-and-flushing">Buffering and flushing</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../app-framework/option-framework.html">The option framework</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/option-framework.html#the-option-class">The option class</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/option-framework.html#command-line-options-and-the-option-dialog">Command line options and the option dialog</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/option-framework.html#option-categories">Option categories</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/option-framework.html#instantiating-options">Instantiating options</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/option-framework.html#getting-and-setting-option-values">Getting and setting option values</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/option-framework.html#option-processing-order">Option processing order</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/option-framework.html#command-line-option-syntax">Command line option syntax</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/option-framework.html#implementing-your-own-options">Implementing your own options</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/option-framework.html#standard-options">Standard options</a></li>
        </ul></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../app-framework/compiler-framework.html">The compiler framework</a></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../app-framework/implement-your-application.html">How to implement your own application</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/implement-your-application.html#the-runinternal-method">The runInternal method</a></li>
        </ul></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../app-framework/registration.html">Application registration</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/registration.html#multi-threaded-applications">Multi-threaded applications</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/registration.html#unit-tests">Unit tests</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../app-framework/registration.html#running-an-application-from-another-application">Running an application from another application</a></li>
        </ul></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../app-framework/execution.html">Execution</a></li>
      </ul></li>
     <li class="toc-item toc-item-parent">
      <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../dsm/index.html">Design Structure Matrix (DSM) library</a>
      <ul class="sectlevel2">
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../dsm/entrypoint.html">Code organization</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../dsm/algorithm.html">Algorithm and code</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../dsm/busdetection.html">Bus detection algorithms</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../dsm/references.html">References</a></li>
      </ul></li>
     <li class="toc-item toc-item-parent">
      <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../multivalue/index.html">Multi-value Decision Diagrams library</a>
      <ul class="sectlevel2">
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../multivalue/goals.html">Goals</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../multivalue/variables-and-relations.html">Variables and relations</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../multivalue/combining-relations.html">Combining relations</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../multivalue/computing.html">Computing</a></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../multivalue/practical-usage.html">Practical usage</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../multivalue/practical-usage.html#variables">Variables</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="../multivalue/practical-usage.html#trees-and-relations">Trees and relations</a></li>
        </ul></li>
      </ul></li>
     <li class="toc-cur-page-ancestor toc-item toc-item-parent expanded">
      <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="index.html">Rail diagram generator</a>
      <ul class="sectlevel2">
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="introduction.html">Introduction</a></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="examples.html">Examples</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="examples.html#diagrams-and-sequences">Diagrams and sequences</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="examples.html#choices">Choices</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="examples.html#optional">Optional</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="examples.html#repetition">Repetition</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="examples.html#splitting-long-sequences">Splitting long sequences</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="examples.html#referencing-a-path-in-the-diagram">Referencing a path in the diagram</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="examples.html#terminals">Terminals</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="examples.html#meta-terminals">Meta-terminals</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="examples.html#further-reading">Further reading</a></li>
        </ul></li>
       <li class="toc-cur-page toc-item toc-item-parent expanded">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="#">Customizing output</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="#syntax-of-the-properties-file">Syntax of the properties file</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="#kinds-of-values">Kinds of values</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="#global-settings">Global settings</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="#diagram-settings">Diagram settings</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="#empty-node">Empty node</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="#branch-label">Branch label</a></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="#name-node">Name node</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#terminal-text-and-box-properties">Terminal text and box properties</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#meta-terminal-text-and-box-properties">Meta-terminal text and box properties</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#non-terminal-text-and-box-properties">Non-terminal text and box properties</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#token-text-translations">Token text translations</a></li>
          </ul></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="#sequence">Sequence</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="#choice">Choice</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="#repetition">Repetition</a></li>
         <li class="toc-item toc-item-parent">
          <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="#debugging-properties">Debugging properties</a>
          <ul class="sectlevel4">
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#hierarchy">Hierarchy</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#constraint-solving">Constraint solving</a></li>
           <li class="toc-item">
            <div class="toc-item-marker"></div><a href="#coordinates">Coordinates</a></li>
          </ul></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="#default-property-values">Default property values</a></li>
        </ul></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="commandline.html">Command-line arguments</a></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="lexical-syntax.html">Lexical syntax</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="lexical-syntax.html#whitespace">Whitespace</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="lexical-syntax.html#comments">Comments</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="lexical-syntax.html#terminals">Terminals</a></li>
        </ul></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="grammar.html">Grammar</a></li>
       <li class="toc-item toc-item-parent">
        <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="debugging.html">Debugging</a>
        <ul class="sectlevel3">
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="debugging.html#global-internal-structure-of-the-generator">Global internal structure of the generator</a></li>
         <li class="toc-item">
          <div class="toc-item-marker"></div><a href="debugging.html#analyzing-output">Analyzing output</a></li>
        </ul></li>
      </ul></li>
     <li class="toc-item toc-item-parent">
      <div class="toc-item-marker" onclick="tocToggle(this); return false;"></div><a href="../setext/index.html">SeText scanner/parser generator</a>
      <ul class="sectlevel2">
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../setext/lexical-syntax.html">SeText lexical syntax</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../setext/specifying-lexical-syntax.html">Specifying lexical syntax using SeText</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../setext/regular-expressions.html">Regular expressions</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../setext/terminal-descriptions.html">Terminal descriptions</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../setext/imports.html">Imports</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../setext/scanner-hooks.html">Scanner hooks</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../setext/specifying-grammars.html">Specifying grammars using SeText</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../setext/parser-hooks.html">Parser hooks</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../setext/usage-hints.html">Usage hints</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../setext/generated-scanners-parsers.html">Generated scanners/parsers</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../setext/using-in-an-eclipse-plugin-project.html">Using SeText in an Eclipse Plug-in Project</a></li>
       <li class="toc-item">
        <div class="toc-item-marker"></div><a href="../setext/limitations.html">Limitations</a></li>
      </ul></li>
     <li class="toc-item">
      <div class="toc-item-marker"></div><a href="../legal.html">Legal</a></li>
    </ul>
   </div>
  </div>
  <div id="content">
   <div id="breadcrumbs">
    <a class="breadcrumb" href="../index.html">Eclipse ESCET™ development documentation</a> &gt; <a class="breadcrumb" href="index.html">Rail diagram generator</a> &gt; <span class="breadcrumb">Customizing output</span>
   </div>
   <h2 id="customizing-output"><a class="anchor" href="#"></a>Customizing output</h2>
   <div class="paragraph">
    <p>The program can take a properties file to translate terminals and non-terminals. The same file can also contain settings to modify shape, color, fonts, and spacing of almost everything.</p>
   </div>
   <div class="sect3">
    <h3 id="syntax-of-the-properties-file"><a class="anchor" href="#syntax-of-the-properties-file"></a>Syntax of the properties file</h3>
    <div class="paragraph">
     <p>The properties file used by the program is a normal Java properties file. Its syntax is described in the <a href="https://docs.oracle.com/en/java/javase/21/docs/api/java.base/java/util/Properties.html#load(java.io.Reader)">Java 21 API Specification</a>.</p>
    </div>
    <div class="paragraph">
     <p>In short:</p>
    </div>
    <div class="ulist">
     <ul>
      <li>
       <p>It is a file format that consists of lines of text.</p></li>
      <li>
       <p>Empty lines are allowed and are skipped.</p></li>
      <li>
       <p>Lines beginning with <code>#</code> or <code>!</code> are considered to be comment lines and are ignored.</p></li>
      <li>
       <p>Data lines contain key/value pairs.</p></li>
      <li>
       <p>By convention, properties files use the <code>.props</code> extension to their name.</p></li>
     </ul>
    </div>
    <div class="paragraph">
     <p>Here, a key of a data line is a sequence of words, separated by a dot, for example, <code>terminal.token.Identifier</code>. The key is followed by an optional but recommended separator character, either <code>:</code> or <code>=</code>. The remainder of the line is the value part, where leading and trailing white space is removed.</p>
    </div>
    <div class="paragraph">
     <p>The properties file format uses <code>\</code> as continuation character to the next line and also as escape character.</p>
    </div>
   </div>
   <div class="sect3">
    <h3 id="kinds-of-values"><a class="anchor" href="#kinds-of-values"></a>Kinds of values</h3>
    <div class="paragraph">
     <p>In the tables below, the properties keys recognized by the program are listed along with an example and an expected value.</p>
    </div>
    <div class="paragraph">
     <p>This table lists the used expected values, and gives some more information about them.</p>
    </div>
    <table class="tableblock frame-all grid-all stretch">
     <colgroup>
      <col style="width: 20%;">
      <col style="width: 20%;">
      <col style="width: 60%;">
     </colgroup>
     <thead>
      <tr>
       <th class="tableblock halign-left valign-top">Type name</th>
       <th class="tableblock halign-left valign-top">Examples</th>
       <th class="tableblock halign-left valign-top">Description</th>
      </tr>
     </thead>
     <tbody>
      <tr>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">Boolean</p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock"><code>yes</code>, `false'</p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">Boolean value to enable or disable a flag.</p></td>
      </tr>
      <tr>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">RGB color</p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock"><code>151 7 230</code></p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">Three integer numbers between <code>0</code> and <code>255</code> inclusive, separated by spaces.</p></td>
      </tr>
      <tr>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">Integer</p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock"><code>10</code></p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">Integer value, usually with ‘pixel’ unit.</p></td>
      </tr>
      <tr>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">Font name</p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock"><code>Serif</code></p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">Name of the font to use. The program currently supports the <code>Dialog</code>, <code>DialogInput</code>, <code>Monospaced</code>, <code>Serif</code>, and <code>SansSerif</code> fonts.</p></td>
      </tr>
      <tr>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">Font height</p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock"><code>12</code></p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">Integer number specifying the point size of the font.</p></td>
      </tr>
      <tr>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">Font style</p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock"><code>plain</code></p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">Style of the font. The program currently supports <code>plain</code>, <code>bold</code>, and <code>italics</code> styles.</p></td>
      </tr>
      <tr>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">Text</p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock"><code>literal</code></p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">Arbitrary text to display for a token.</p></td>
      </tr>
     </tbody>
    </table>
   </div>
   <div class="sect3">
    <h3 id="global-settings"><a class="anchor" href="#global-settings"></a>Global settings</h3>
    <div class="paragraph">
     <p>The following settings affect background and the rail line.</p>
    </div>
    <table class="tableblock frame-all grid-all stretch">
     <colgroup>
      <col style="width: 20%;">
      <col style="width: 20%;">
      <col style="width: 60%;">
     </colgroup>
     <thead>
      <tr>
       <th class="tableblock halign-left valign-top">Property name</th>
       <th class="tableblock halign-left valign-top">Value type</th>
       <th class="tableblock halign-left valign-top">Description</th>
      </tr>
     </thead>
     <tbody>
      <tr>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock"><code>diagram.background.color</code></p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">RGB color</p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">Color of the background of the generated image.</p></td>
      </tr>
      <tr>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock"><code>rail.linewidth</code></p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">Integer</p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">Width of the rail line.</p></td>
      </tr>
      <tr>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock"><code>rail.color</code></p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">RGB color</p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">Color of the rail line.</p></td>
      </tr>
     </tbody>
    </table>
   </div>
   <div class="sect3">
    <h3 id="diagram-settings"><a class="anchor" href="#diagram-settings"></a>Diagram settings</h3>
    <div class="paragraph">
     <p>The diagram settings configure the global layout of an image. At the top is a header line with the name of the rule, below it are one or more railroad pictures with some additional rail at both ends.</p>
    </div>
    <table class="tableblock frame-all grid-all stretch">
     <colgroup>
      <col style="width: 33.3333%;">
      <col style="width: 16.6666%;">
      <col style="width: 50.0001%;">
     </colgroup>
     <thead>
      <tr>
       <th class="tableblock halign-left valign-top">Property name</th>
       <th class="tableblock halign-left valign-top">Value type</th>
       <th class="tableblock halign-left valign-top">Description</th>
      </tr>
     </thead>
     <tbody>
      <tr>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock"><code>rule.padding.top</code></p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">Integer</p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">Amount of space above the header line.</p></td>
      </tr>
      <tr>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock"><code>rule.padding.left</code></p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">Integer</p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">Amount of space left of the header line.</p></td>
      </tr>
      <tr>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock"><code>rule.padding.bottom</code></p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">Integer</p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">Amount of space between the last railroad picture and the bottom of the diagram.</p></td>
      </tr>
      <tr>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock"><code>rule.padding.right</code></p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">Integer</p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">Minimum amount of space right of the header line.</p></td>
      </tr>
      <tr>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock"><code>rule.diagram.padding.top</code></p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">Integer</p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">Amount of space above each railroad picture.</p></td>
      </tr>
      <tr>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock"><code>rule.diagram.padding.left</code></p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">Integer</p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">Amount of space left of each railroad picture.</p></td>
      </tr>
      <tr>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock"><code>rule.diagram.lead.width</code></p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">Integer</p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">Horizontal length of the rail line before the railroad picture.</p></td>
      </tr>
      <tr>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock"><code>rule.diagram.trail.width</code></p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">Integer</p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">Horizontal length of the rail line after the railroad picture.</p></td>
      </tr>
      <tr>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock"><code>diagram-header.text.color</code></p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">RGB color</p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">Color of the diagram header text.</p></td>
      </tr>
      <tr>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock"><code>diagram-header.text.font</code></p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">Font name</p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">Font of the diagram header text.</p></td>
      </tr>
      <tr>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock"><code>diagram-header.text.font.size</code></p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">Font height</p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">Font size in points of the diagram header text.</p></td>
      </tr>
      <tr>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock"><code>diagram-header.text.font.style</code></p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">Font style</p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">Style of the diagram header text.</p></td>
      </tr>
     </tbody>
    </table>
   </div>
   <div class="sect3">
    <h3 id="empty-node"><a class="anchor" href="#empty-node"></a>Empty node</h3>
    <div class="paragraph">
     <p>Each kind of node has a number of settings as well, starting with the simplest node, <code>()</code>.</p>
    </div>
    <table class="tableblock frame-all grid-all stretch">
     <colgroup>
      <col style="width: 33.3333%;">
      <col style="width: 16.6666%;">
      <col style="width: 50.0001%;">
     </colgroup>
     <thead>
      <tr>
       <th class="tableblock halign-left valign-top">Property name</th>
       <th class="tableblock halign-left valign-top">Value type</th>
       <th class="tableblock halign-left valign-top">Description</th>
      </tr>
     </thead>
     <tbody>
      <tr>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock"><code>empty.width</code></p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">Integer</p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">Horizontal length of the empty node.</p></td>
      </tr>
     </tbody>
    </table>
   </div>
   <div class="sect3">
    <h3 id="branch-label"><a class="anchor" href="#branch-label"></a>Branch label</h3>
    <div class="paragraph">
     <p>The bracketed string <code>[refname]</code> node configuration settings are listed below.</p>
    </div>
    <table class="tableblock frame-all grid-all stretch">
     <colgroup>
      <col style="width: 33.3333%;">
      <col style="width: 16.6666%;">
      <col style="width: 50.0001%;">
     </colgroup>
     <thead>
      <tr>
       <th class="tableblock halign-left valign-top">Property name</th>
       <th class="tableblock halign-left valign-top">Value type</th>
       <th class="tableblock halign-left valign-top">Description</th>
      </tr>
     </thead>
     <tbody>
      <tr>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock"><code>branch-label.padding.left</code></p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">Integer</p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">Amount of space at the left of the label text.</p></td>
      </tr>
      <tr>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock"><code>branch-label.padding.right</code></p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">Integer</p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">Amount of space at the right of the label text.</p></td>
      </tr>
      <tr>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock"><code>branch-label.padding.top</code></p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">Integer</p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">Amount of space above the label text.</p></td>
      </tr>
      <tr>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock"><code>branch-label.padding.bottom</code></p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">Integer</p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">Amount of space between the label text and the rail line.</p></td>
      </tr>
      <tr>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock"><code>branch-label.min-width</code></p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">Integer</p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">Minimum horizontal length of the label node.</p></td>
      </tr>
      <tr>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock"><code>branch-label.text.color</code></p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">RGB color</p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">Color of the label text.</p></td>
      </tr>
      <tr>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock"><code>branch-label.text.font</code></p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">Font name</p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">Font used for the label text.</p></td>
      </tr>
      <tr>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock"><code>branch-label.text.font.size</code></p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">Font height</p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">Font size in pt of the label text.</p></td>
      </tr>
      <tr>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock"><code>branch-label.text.font.style</code></p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">Font style</p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">Font style of the label text.</p></td>
      </tr>
     </tbody>
    </table>
   </div>
   <div class="sect3">
    <h3 id="name-node"><a class="anchor" href="#name-node"></a>Name node</h3>
    <div class="paragraph">
     <p>A name node is a string of text within a box. The text is often a single name, and the box may have rounded corners. At the left and right of the box, a rail line is connected.</p>
    </div>
    <div class="paragraph">
     <p>First the configuration of the rail lines, followed by the configuration settings of the box and the text.</p>
    </div>
    <table class="tableblock frame-all grid-all stretch">
     <colgroup>
      <col style="width: 33.3333%;">
      <col style="width: 16.6666%;">
      <col style="width: 50.0001%;">
     </colgroup>
     <thead>
      <tr>
       <th class="tableblock halign-left valign-top">Property name</th>
       <th class="tableblock halign-left valign-top">Value type</th>
       <th class="tableblock halign-left valign-top">Description</th>
      </tr>
     </thead>
     <tbody>
      <tr>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock"><code>name.rail.entry.width</code></p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">Integer</p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">Horizontal length of the rail line at the left of the box.</p></td>
      </tr>
      <tr>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock"><code>name.rail.exit.width</code></p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">Integer</p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">Horizontal length of the rail line at the right of the box.</p></td>
      </tr>
     </tbody>
    </table>
    <div class="paragraph">
     <p>There are three configurations for name and box. One for terminals, one for meta-terminals, and one for non-terminals. The structure of the settings is the same for all three, their default values are a little different, in particular in choices of corner radius and font.</p>
    </div>
    <div class="sect4">
     <h4 id="terminal-text-and-box-properties"><a class="anchor" href="#terminal-text-and-box-properties"></a>Terminal text and box properties</h4>
     <table class="tableblock frame-all grid-all stretch">
      <colgroup>
       <col style="width: 33.3333%;">
       <col style="width: 16.6666%;">
       <col style="width: 50.0001%;">
      </colgroup>
      <thead>
       <tr>
        <th class="tableblock halign-left valign-top">Property name</th>
        <th class="tableblock halign-left valign-top">Value type</th>
        <th class="tableblock halign-left valign-top">Description</th>
       </tr>
      </thead>
      <tbody>
       <tr>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock"><code>terminal.name.padding.horizontal</code></p></td>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock">Integer</p></td>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock">Amount of horizontal space between the text and the box around the text.</p></td>
       </tr>
       <tr>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock"><code>terminal.name.padding.vertical</code></p></td>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock">Integer</p></td>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock">Amount of vertical space between the text and the box around the text.</p></td>
       </tr>
       <tr>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock"><code>terminal.corner.radius</code></p></td>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock">Integer</p></td>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock">Radius of the corners of the box. <code>0</code> means a rectangular box.</p></td>
       </tr>
       <tr>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock"><code>terminal.box.color</code></p></td>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock">RGB color</p></td>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock">Color of the line of the box.</p></td>
       </tr>
       <tr>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock"><code>terminal.box.linewidth</code></p></td>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock">Integer</p></td>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock">Width of the line of the box.</p></td>
       </tr>
       <tr>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock"><code>terminal.text.color</code></p></td>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock">RGB color</p></td>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock">Color of the terminal text.</p></td>
       </tr>
       <tr>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock"><code>terminal.text.font</code></p></td>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock">Font name</p></td>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock">Font used for the terminal text.</p></td>
       </tr>
       <tr>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock"><code>terminal.text.font.size</code></p></td>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock">Font height</p></td>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock">Height of the terminal text.</p></td>
       </tr>
       <tr>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock"><code>terminal.text.font.style</code></p></td>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock">Font style</p></td>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock">Style of the terminal text.</p></td>
       </tr>
      </tbody>
     </table>
    </div>
    <div class="sect4">
     <h4 id="meta-terminal-text-and-box-properties"><a class="anchor" href="#meta-terminal-text-and-box-properties"></a>Meta-terminal text and box properties</h4>
     <table class="tableblock frame-all grid-all stretch">
      <colgroup>
       <col style="width: 33.3333%;">
       <col style="width: 16.6666%;">
       <col style="width: 50.0001%;">
      </colgroup>
      <thead>
       <tr>
        <th class="tableblock halign-left valign-top">Property name</th>
        <th class="tableblock halign-left valign-top">Value type</th>
        <th class="tableblock halign-left valign-top">Description</th>
       </tr>
      </thead>
      <tbody>
       <tr>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock"><code>meta-terminal.name.padding.horizontal</code></p></td>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock">Integer</p></td>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock">Amount of horizontal space between the text and the box around the text.</p></td>
       </tr>
       <tr>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock"><code>meta-terminal.name.padding.vertical</code></p></td>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock">Integer</p></td>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock">Amount of vertical space between the text and the box around the text.</p></td>
       </tr>
       <tr>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock"><code>meta-terminal.corner.radius</code></p></td>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock">Integer</p></td>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock">Radius of the corners of the box. <code>0</code> means a rectangular box.</p></td>
       </tr>
       <tr>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock"><code>meta-terminal.box.color</code></p></td>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock">RGB color</p></td>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock">Color of the line of the box.</p></td>
       </tr>
       <tr>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock"><code>meta-terminal.box.linewidth</code></p></td>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock">Integer</p></td>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock">Width of the line of the box.</p></td>
       </tr>
       <tr>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock"><code>meta-terminal.text.color</code></p></td>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock">RGB color</p></td>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock">Color of the meta-terminal text.</p></td>
       </tr>
       <tr>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock"><code>meta-terminal.text.font</code></p></td>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock">Font name</p></td>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock">Font used for the meta-terminal text.</p></td>
       </tr>
       <tr>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock"><code>meta-terminal.text.font.size</code></p></td>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock">Font height</p></td>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock">Height of the meta-terminal text.</p></td>
       </tr>
       <tr>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock"><code>meta-terminal.text.font.style</code></p></td>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock">Font style</p></td>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock">Style of the meta-terminal text.</p></td>
       </tr>
      </tbody>
     </table>
    </div>
    <div class="sect4">
     <h4 id="non-terminal-text-and-box-properties"><a class="anchor" href="#non-terminal-text-and-box-properties"></a>Non-terminal text and box properties</h4>
     <table class="tableblock frame-all grid-all stretch">
      <colgroup>
       <col style="width: 33.3333%;">
       <col style="width: 16.6666%;">
       <col style="width: 50.0001%;">
      </colgroup>
      <thead>
       <tr>
        <th class="tableblock halign-left valign-top">Property name</th>
        <th class="tableblock halign-left valign-top">Value type</th>
        <th class="tableblock halign-left valign-top">Description</th>
       </tr>
      </thead>
      <tbody>
       <tr>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock"><code>nonterminal.name.padding.horizontal</code></p></td>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock">Integer</p></td>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock">Amount of horizontal space between the text and the box around the text.</p></td>
       </tr>
       <tr>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock"><code>nonterminal.name.padding.vertical</code></p></td>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock">Integer</p></td>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock">Amount of vertical space between the text and the box around the text.</p></td>
       </tr>
       <tr>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock"><code>nonterminal.corner.radius</code></p></td>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock">Integer</p></td>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock">Radius of the corners of the box. <code>0</code> means a rectangular box.</p></td>
       </tr>
       <tr>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock"><code>nonterminal.box.color</code></p></td>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock">RGB color</p></td>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock">Color of the line of the box.</p></td>
       </tr>
       <tr>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock"><code>nonterminal.box.linewidth</code></p></td>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock">Integer</p></td>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock">Width of the line of the box.</p></td>
       </tr>
       <tr>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock"><code>nonterminal.text.color</code></p></td>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock">RGB color</p></td>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock">Color of the non-terminal text.</p></td>
       </tr>
       <tr>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock"><code>nonterminal.text.font</code></p></td>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock">Font name</p></td>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock">Font used for the non-terminal text.</p></td>
       </tr>
       <tr>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock"><code>nonterminal.text.font.size</code></p></td>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock">Font height</p></td>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock">Height of the non-terminal text.</p></td>
       </tr>
       <tr>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock"><code>nonterminal.text.font.style</code></p></td>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock">Font style</p></td>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock">Style of the non-terminal text.</p></td>
       </tr>
      </tbody>
     </table>
    </div>
    <div class="sect4">
     <h4 id="token-text-translations"><a class="anchor" href="#token-text-translations"></a>Token text translations</h4>
     <div class="paragraph">
      <p>In the diagram input files, token names may be used, but terminals often contain other symbols. The translation between the token name and the text it should display can also be configured.</p>
     </div>
     <div class="paragraph">
      <p>There are three groups of settings. Different settings within a group only differ in the name of the token that they translate. Such a name is listed here as <code>&lt;token-name&gt;</code>.</p>
     </div>
     <table class="tableblock frame-all grid-all stretch">
      <colgroup>
       <col style="width: 28.5714%;">
       <col style="width: 14.2857%;">
       <col style="width: 57.1429%;">
      </colgroup>
      <thead>
       <tr>
        <th class="tableblock halign-left valign-top">Property name</th>
        <th class="tableblock halign-left valign-top">Value type</th>
        <th class="tableblock halign-left valign-top">Description</th>
       </tr>
      </thead>
      <tbody>
       <tr>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock"><code>terminal.token.&lt;token-name&gt;</code></p></td>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock">Text</p></td>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock">The literal text to display in the diagram for terminal token <code>&lt;token-name&gt;</code>.</p></td>
       </tr>
       <tr>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock"><code>meta-terminal.&lt;token-name&gt;</code></p></td>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock">Text</p></td>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock">The literal text to display in the diagram for meta-terminal token <code>&lt;token-name&gt;</code>.</p></td>
       </tr>
       <tr>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock"><code>nonterminal.token.&lt;token-name&gt;</code></p></td>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock">Text</p></td>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock">The literal text to display in the diagram for non-terminal token <code>&lt;token-name&gt;</code>.</p></td>
       </tr>
      </tbody>
     </table>
     <div class="paragraph">
      <p>All tokens must have a different name. Both terminals and meta-terminals token lists are assumed to be complete. The non-terminal list is fully optional, and the default choice if a token name cannot be found. All missing entries use the token name as their text.</p>
     </div>
     <div class="paragraph">
      <p>Note that the property file reader applies some interpretation to the text as well so what you enter in the file may not be what you get. Please check the <a href="#syntax-of-the-properties-file">property file syntax</a> section for details.</p>
     </div>
    </div>
   </div>
   <div class="sect3">
    <h3 id="sequence"><a class="anchor" href="#sequence"></a>Sequence</h3>
    <div class="paragraph">
     <p>A sequence connects one or more child diagram nodes in one or more rows such that they are all visited in sequential order.</p>
    </div>
    <div class="paragraph">
     <p>Its configuration settings cover the elements around the child nodes.</p>
    </div>
    <table class="tableblock frame-all grid-all stretch">
     <colgroup>
      <col style="width: 33.3333%;">
      <col style="width: 16.6666%;">
      <col style="width: 50.0001%;">
     </colgroup>
     <thead>
      <tr>
       <th class="tableblock halign-left valign-top">Property name</th>
       <th class="tableblock halign-left valign-top">Value type</th>
       <th class="tableblock halign-left valign-top">Description</th>
      </tr>
     </thead>
     <tbody>
      <tr>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock"><code>sequence.padding.first-row.prefix</code></p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">Integer</p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">Amount of space before the first child at the first row.</p></td>
      </tr>
      <tr>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock"><code>sequence.padding.other-row.prefix</code></p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">Integer</p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">Amount of space left of the left connecting vertical line to a next row.</p></td>
      </tr>
      <tr>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock"><code>sequence.padding.row.suffix</code></p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">Integer</p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">If there is more than one row, the minimal amount of space between the right vertical line connecting a next row, and the vertical line up to the exit.</p></td>
      </tr>
      <tr>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock"><code>sequence.padding.interrow</code></p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">Integer</p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">Minimal amount of space between the bottom of a row, and the connecting horizontal line to the next row beneath it. Also, the minimal amount of space between the same horizontal line and the top of the next row.</p></td>
      </tr>
      <tr>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock"><code>sequence.arc-radius</code></p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">Integer</p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">Radius of the arcs connecting horizontal lines with vertical lines.</p></td>
      </tr>
     </tbody>
    </table>
   </div>
   <div class="sect3">
    <h3 id="choice"><a class="anchor" href="#choice"></a>Choice</h3>
    <div class="paragraph">
     <p>The choice node expresses a choice between one of the child diagram nodes.</p>
    </div>
    <div class="paragraph">
     <p>Its configurable properties are:</p>
    </div>
    <table class="tableblock frame-all grid-all stretch">
     <colgroup>
      <col style="width: 33.3333%;">
      <col style="width: 16.6666%;">
      <col style="width: 50.0001%;">
     </colgroup>
     <thead>
      <tr>
       <th class="tableblock halign-left valign-top">Property name</th>
       <th class="tableblock halign-left valign-top">Value type</th>
       <th class="tableblock halign-left valign-top">Description</th>
      </tr>
     </thead>
     <tbody>
      <tr>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock"><code>choice.arc-radius</code></p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">Integer</p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">Radius of the arcs connecting horizontal lines with vertical lines.</p></td>
      </tr>
      <tr>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock"><code>choice.padding.vertical</code></p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">Integer</p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">Minimal amount of vertical space between two child diagrams.</p></td>
      </tr>
     </tbody>
    </table>
    <div class="paragraph">
     <p>Note that the space between the first and second child is not only influenced by the <code>choice.padding.vertical</code> setting, but also influenced by the <code>choice.arc-radius</code>, as two arcs have to fit vertically as well.</p>
    </div>
   </div>
   <div class="sect3">
    <h3 id="repetition"><a class="anchor" href="#repetition"></a>Repetition</h3>
    <div class="paragraph">
     <p>The repetition node <code>A + B</code> expresses an alternating execution sequence <code>A(BA)*</code>. The <code>A</code> child node is referred to as <em>forward</em>, as its execution runs normally from left to right in the diagram, while the <code>B</code> child is referred to as <em>backward</em> as its execution normally runs from right to left. The repetition is also known as <em>loop</em> due to the circular shape of the node.</p>
    </div>
    <div class="paragraph">
     <p>Its configuration settings are:</p>
    </div>
    <table class="tableblock frame-all grid-all stretch">
     <colgroup>
      <col style="width: 33.3333%;">
      <col style="width: 16.6666%;">
      <col style="width: 50.0001%;">
     </colgroup>
     <thead>
      <tr>
       <th class="tableblock halign-left valign-top">Property name</th>
       <th class="tableblock halign-left valign-top">Value type</th>
       <th class="tableblock halign-left valign-top">Description</th>
      </tr>
     </thead>
     <tbody>
      <tr>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock"><code>loop.arc-radius</code></p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">Integer</p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">Radius of the arcs connecting horizontal lines with vertical lines.</p></td>
      </tr>
      <tr>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock"><code>loop.padding.vertical</code></p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">Integer</p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">Amount of vertical space between the nodes of the forward and backward sequences.</p></td>
      </tr>
      <tr>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock"><code>loop.padding.left</code></p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">Integer</p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">Amount of space left of the left vertical line.</p></td>
      </tr>
      <tr>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock"><code>loop.padding.right</code></p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">Integer</p></td>
       <td class="tableblock halign-left valign-top">
        <p class="tableblock">Amount of space right of the right vertical line.</p></td>
      </tr>
     </tbody>
    </table>
    <div class="paragraph">
     <p>The <code>loop.padding.left</code> and <code>loop.padding.right</code> become important when a diagram contains a sequence of repetitions. If you set the left and right padding to <code>0</code>, the following may happen:</p>
    </div>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-raildiagram hljs" data-lang="raildiagram">SequenceLoops : (A + B) (C + D) ;</code></pre>
     </div>
    </div>
    <div class="paragraph">
     <p>This results in:</p>
    </div>
    <div class="imageblock">
     <div class="content">
      <img src="sequence_loops.rr.png" alt="Sequence of loops">
     </div>
    </div>
    <div class="paragraph">
     <p>Other nodes all have some space at either end, making it less apparent in those cases.</p>
    </div>
   </div>
   <div class="sect3">
    <h3 id="debugging-properties"><a class="anchor" href="#debugging-properties"></a>Debugging properties</h3>
    <div class="paragraph">
     <p>A diagram is actually a tree of simpler diagrams where at each node in the tree a set of position equations is solved for positioning all elements in its sub-tree. This happens in two sweeps through the tree. First a bottom-up computation of size and relative position of elements in their sub-tree is performed. In the second top-down sweep assignment of horizontal and vertical absolute offsets to all nodes is performed, giving all elements their final absolute position in the diagram. Output is produced by a walk over all nodes in the tree, and copying the elements with their absolute positions to the output.</p>
    </div>
    <div class="paragraph">
     <p>There are several flags for generating detailed output of the above process to support debugging at several points in the computations.</p>
    </div>
    <div class="sect4">
     <h4 id="hierarchy"><a class="anchor" href="#hierarchy"></a>Hierarchy</h4>
     <div class="paragraph">
      <p>To view the tree hierarchy in the diagram, the <code>debug.structure</code> flag can be used.</p>
     </div>
     <table class="tableblock frame-all grid-all stretch">
      <colgroup>
       <col style="width: 33.3333%;">
       <col style="width: 16.6666%;">
       <col style="width: 50.0001%;">
      </colgroup>
      <thead>
       <tr>
        <th class="tableblock halign-left valign-top">Property name</th>
        <th class="tableblock halign-left valign-top">Value type</th>
        <th class="tableblock halign-left valign-top">Description</th>
       </tr>
      </thead>
      <tbody>
       <tr>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock"><code>debug.structure</code></p></td>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock">Boolean</p></td>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock">Dump internal structure of the diagram.</p></td>
       </tr>
      </tbody>
     </table>
    </div>
    <div class="sect4">
     <h4 id="constraint-solving"><a class="anchor" href="#constraint-solving"></a>Constraint solving</h4>
     <div class="paragraph">
      <p>Positions are computed by solving two sets of constraint equations at each node in the tree, one for horizontal positioning, and one for vertical positioning. The <code>debug.equations</code> flag shows the variables and equations, the <code>debug.solver</code> shows the solving process. Due to the large number of variables and equations in a typical diagram, enabling these settings produces a lot of detailed debug output.</p>
     </div>
     <table class="tableblock frame-all grid-all stretch">
      <colgroup>
       <col style="width: 33.3333%;">
       <col style="width: 16.6666%;">
       <col style="width: 50.0001%;">
      </colgroup>
      <thead>
       <tr>
        <th class="tableblock halign-left valign-top">Property name</th>
        <th class="tableblock halign-left valign-top">Value type</th>
        <th class="tableblock halign-left valign-top">Description</th>
       </tr>
      </thead>
      <tbody>
       <tr>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock"><code>debug.equations</code></p></td>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock">Boolean</p></td>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock">Dump positioning equations for the graphical elements.</p></td>
       </tr>
       <tr>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock"><code>debug.solver</code></p></td>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock">Boolean</p></td>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock">Dump reasoning and deciding edge position values for the graphical elements.</p></td>
       </tr>
      </tbody>
     </table>
    </div>
    <div class="sect4">
     <h4 id="coordinates"><a class="anchor" href="#coordinates"></a>Coordinates</h4>
     <div class="paragraph">
      <p>To debug problems in produced output, the following flags are useful. The <code>debug.rel_coordinates</code> flag shows position information at each level of the tree separately, this is mostly useful to find problems at a single level of a diagram. The <code>debug.abs_coordinates</code> flag shows the same position information, except all coordinates use the same top-left origin, enabling verification of positions between different levels in the hierarchy.</p>
     </div>
     <table class="tableblock frame-all grid-all stretch">
      <colgroup>
       <col style="width: 33.3333%;">
       <col style="width: 16.6666%;">
       <col style="width: 50.0001%;">
      </colgroup>
      <thead>
       <tr>
        <th class="tableblock halign-left valign-top">Property name</th>
        <th class="tableblock halign-left valign-top">Value type</th>
        <th class="tableblock halign-left valign-top">Description</th>
       </tr>
      </thead>
      <tbody>
       <tr>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock"><code>debug.rel_coordinates</code></p></td>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock">Boolean</p></td>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock">Dump coordinates of the graphical elements and child node positions within each element.</p></td>
       </tr>
       <tr>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock"><code>debug.abs_coordinates</code></p></td>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock">Boolean</p></td>
        <td class="tableblock halign-left valign-top">
         <p class="tableblock">Dump absolute coordinates of the graphical elements and child node positions of the diagram.</p></td>
       </tr>
      </tbody>
     </table>
     <div class="paragraph">
      <p>Note that positions are stated as inclusive horizontal and vertical edge positions everywhere. This means that element <code>x[1—​1], y[1—​2]</code> is one unit wide horizontally, and two units vertically. Also, an element <code>x[2—​7], y[1—​2]</code> is directly next to the previous element, there is no space between them. Zero width or height is shown as an interval with the first value larger than the second value, for example <code>x[4—​3]</code>.</p>
     </div>
    </div>
   </div>
   <div class="sect3">
    <h3 id="default-property-values"><a class="anchor" href="#default-property-values"></a>Default property values</h3>
    <div class="paragraph">
     <p>The default values for the various properties are as follows:</p>
    </div>
    <div class="listingblock">
     <div class="content">
      <pre class="highlightjs highlight"><code class="language-properties hljs" data-lang="properties"># Background.
diagram.background.color: 255 255 255

# Rail.
rail.linewidth: 1.0
rail.color:     0 0 0

# Diagram rule.
rule.padding.top:          10
rule.padding.left:         10
rule.padding.bottom:       10
rule.padding.right:        10
rule.diagram.padding.top:  10
rule.diagram.padding.left: 10
rule.diagram.lead.width:   20
rule.diagram.trail.width:  20

# Choice.
choice.arc-radius:       10
choice.padding.vertical:  5

# Loop.
loop.arc-radius:       10
loop.padding.vertical:  5
loop.padding.left:      5
loop.padding.right:     5

# Sequence.
sequence.padding.first-row.prefix:  0
sequence.padding.other-row.prefix:  5
sequence.padding.row.suffix:        5
sequence.padding.interrow:          8
sequence.arc-radius:               10

# Branch label.
branch-label.padding.left:    5
branch-label.padding.right:   5
branch-label.padding.top:     5
branch-label.padding.bottom:  5
branch-label.min-width:       5
branch-label.text.color:      0 0 0
branch-label.text.font:       SansSerif
branch-label.text.font.size:  16
branch-label.text.font.style: plain

# Empty node.
empty.width: 10

# Name node, width of the entry and exit connections.
name.rail.entry.width: 5
name.rail.exit.width:  5

# Header font and text.
diagram-header.text.color:      0 0 0
diagram-header.text.font:       SansSerif
diagram-header.text.font.size:  16
diagram-header.text.font.style: bold

# 'terminal' name properties.
terminal.name.padding.horizontal: 5
terminal.name.padding.vertical:   5
terminal.corner.radius:           12
terminal.box.color:               0 0 0
terminal.box.linewidth:           1.0
terminal.text.color:              0 0 0
terminal.text.font:               Monospaced
terminal.text.font.size:          18
terminal.text.font.style:         plain

# 'meta-terminal' name properties.
meta-terminal.name.padding.horizontal: 5
meta-terminal.name.padding.vertical:   5
meta-terminal.corner.radius:           12
meta-terminal.box.color:               0 0 0
meta-terminal.box.linewidth:           1.0
meta-terminal.text.color:              0 0 0
meta-terminal.text.font:               SansSerif
meta-terminal.text.font.size:          16
meta-terminal.text.font.style:         plain

# 'nonterminal' name properties.
nonterminal.name.padding.horizontal: 5
nonterminal.name.padding.vertical:   5
nonterminal.corner.radius:           0
nonterminal.box.color:               0 0 0
nonterminal.box.linewidth:           1.0
nonterminal.text.color:              0 0 0
nonterminal.text.font:               SansSerif
nonterminal.text.font.size:          16
nonterminal.text.font.style:         italic

# Token text properties:
# terminal.token.&lt;tokname&gt;: &lt;toktext&gt;, should always be fully specified.
# meta-terminal.&lt;tokname&gt;: &lt;toktext&gt;, should always be fully specified.
# nonterminal.token.&lt;tokname&gt;: &lt;toktext&gt;, with &lt;toktext&gt; optional, default value is &lt;tokname&gt;.

# Debugging support, ordered by topic.
debug.structure:       false
debug.equations:       false
debug.solver:          false
debug.rel_coordinates: false
debug.abs_coordinates: false</code></pre>
     </div>
    </div>
   </div>
  </div>
  <script src="../assets/highlight.min.js"></script>
  <script src="../assets/languages/asciidoc.min.js"></script>
  <script src="../assets/languages/bash.min.js"></script>
  <script src="../assets/languages/bnf.min.js"></script>
  <script src="../assets/languages/c.min.js"></script>
  <script src="../assets/languages/chi.min.js"></script>
  <script src="../assets/languages/cif.min.js"></script>
  <script src="../assets/languages/console.min.js"></script>
  <script src="../assets/languages/css.min.js"></script>
  <script src="../assets/languages/dsm.min.js"></script>
  <script src="../assets/languages/java.min.js"></script>
  <script src="../assets/languages/javascript.min.js"></script>
  <script src="../assets/languages/markdown.min.js"></script>
  <script src="../assets/languages/mcrl2.min.js"></script>
  <script src="../assets/languages/none.min.js"></script>
  <script src="../assets/languages/plcst.min.js"></script>
  <script src="../assets/languages/properties.min.js"></script>
  <script src="../assets/languages/raildiagram.min.js"></script>
  <script src="../assets/languages/setext.min.js"></script>
  <script src="../assets/languages/shell.min.js"></script>
  <script src="../assets/languages/tooldef.min.js"></script>
  <script src="../assets/languages/xml.min.js"></script>
  <script>
if (!hljs.initHighlighting.called) {
  hljs.initHighlighting.called = true
  ;[].slice.call(document.querySelectorAll('pre.highlight > code[data-lang]')).forEach(function (el) { hljs.highlightElement(el) })
}
</script>
  <script type="text/x-mathjax-config">
MathJax.Hub.Config({
  messageStyle: "none",
  tex2jax: {
    inlineMath: [["\\(", "\\)"]],
    displayMath: [["\\[", "\\]"]],
    ignoreClass: "nostem|nolatexmath"
  },
  asciimath2jax: {
    delimiters: [["\\$", "\\$"]],
    ignoreClass: "nostem|noasciimath"
  },
  TeX: { equationNumbers: { autoNumber: "none" } }
})
MathJax.Hub.Register.StartupHook("AsciiMath Jax Ready", function () {
  MathJax.InputJax.AsciiMath.postfilterHooks.Add(function (data, node) {
    if ((node = data.script.parentNode) && (node = node.parentNode) && node.classList.contains("stemblock")) {
      data.math.root.display = "block"
    }
    return data
  })
})
</script>
  <script src="https://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.9/MathJax.js?config=TeX-MML-AM_HTMLorMML"></script><!--
  Copyright (c) 2010, 2024 Contributors to the Eclipse Foundation

  See the NOTICE file(s) distributed with this work for additional
  information regarding copyright ownership.

  This program and the accompanying materials are made available under the terms
  of the MIT License which is available at https://opensource.org/licenses/MIT

  SPDX-License-Identifier: MIT
-->
  <div id="footer">
   <div id="footer-text">
    <span>Eclipse ESCET™ development documentation</span> | <span>Copyright (c) 2010, 2024 Contributors to the Eclipse Foundation</span> | <span>version v6.0</span>
    <br><a href="https://www.eclipse.org">Eclipse Home</a> | <a href="https://www.eclipse.org/legal/privacy.php">Privacy Policy</a> | <a href="https://www.eclipse.org/legal/termsofuse.php">Terms of Use</a> | <a href="https://www.eclipse.org/legal/copyright.php">Copyright Agent</a> | <a href="https://www.eclipse.org/legal">Eclipse Legal</a>
   </div>
  </div>
 </body>
</html>